using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Routing;
using Microsoft.Extensions.Logging;
using Microsoft.AspNetCore.Authorization;
using Microsoft.EntityFrameworkCore;
using AyaNova.Models;
using AyaNova.Api.ControllerHelpers;
using AyaNova.Biz;
using AyaNova.PickList;
using System.Threading.Tasks;

namespace AyaNova.Api.Controllers
{

    [ApiController]
    [ApiVersion("8.0")]
    [Route("api/v{version:apiVersion}/pick-list")]
    [Produces("application/json")]
    [Authorize]
    public class PickListController : ControllerBase
    {
        private readonly AyContext ct;
        private readonly ILogger<PickListController> log;
        private readonly ApiServerState serverState;



        /// <summary>
        /// ctor
        /// </summary>
        /// <param name="dbcontext"></param>
        /// <param name="logger"></param>
        /// <param name="apiServerState"></param>
        public PickListController(AyContext dbcontext, ILogger<PickListController> logger, ApiServerState apiServerState)
        {
            ct = dbcontext;
            log = logger;
            serverState = apiServerState;
        }



        /// <summary>
        /// Get picklist of all Active objects of type specified and filtered by query specified
        /// NOTE: Query is valid only if:
        /// it is an empty string indicating not filtered just selected
        /// if not an empty string, it has at most two space separated strings and one of them is a special TAG specific query that starts with two consecutive periods 
        /// i.e. "some" is valid (single query on all templated fields) 
        /// "..zon some" is valid (all tags like zon and all template fields like some)
        /// "zon some" is NOT valid (missing TAGS indicator), "..zone some re" is NOT valid (too many strings)
        /// Note that this list is capped automatically to return no more than 100 results
        /// </summary>
        /// <param name="ayaType">The AyaType object type to select from</param>
        /// <param name="query">The query to filter the returned list by. Query text as provided will be case sensitively matched to all templated fields. 
        /// Independantely of this, if an addition space separated string that begins with two consecutive periods is encountered that will be considered a separate match to the TAGS collection of each object
        /// So a tag query might be entered as "..zon some" which would match all tags LIKE 'zon' and template fields LIKE 'some'</param>
        /// <param name="inactive">Include inactive objects in the returned list </param>
        /// <param name="preId">Return only one item (for pre-selected items on forms) </param>
        /// <returns>Filtered list</returns>
        [HttpGet("list")]
        public async Task<IActionResult> GetList([FromQuery]AyaType ayaType, [FromQuery]string query, [FromQuery] bool inactive, [FromQuery]long? preId)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //NOTE: these sequence of calls are a little different than other objects due to the nature of rights and stuff with picklists being different

            var PickList = PickListFactory.GetAyaPickList(ayaType);

            //was the name not found as a pick list?
            if (PickList == null)
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            //RIGHTS - NOTE: uniquely to other routes this one checks the actual picklist defined roles itself
            if (!Authorized.HasAnyRole(HttpContext.Items, PickList.AllowedRoles))
                return StatusCode(403, new ApiNotAuthorizedResponse());

            //Instantiate the business object handler
            PickListBiz biz = PickListBiz.GetBiz(ct, HttpContext);

            if (preId == null)
                preId = 0;
            var o = await biz.GetPickListAsync(PickList, query, inactive, (long)preId, log);
            if (o == null)
                return BadRequest(new ApiErrorResponse(biz.Errors));
            else
                return Ok(ApiOkResponse.Response(o));
        }



        /// <summary>
        /// Get PickListTemplate
        /// </summary>
        /// <param name="ayaType"></param>
        /// <returns>The current effective template, either a customized one or the default</returns>
        [HttpGet("template/{ayaType}")]
        public async Task<IActionResult> GetPickListTemplate([FromRoute] AyaType ayaType)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            //Instantiate the business object handler
            PickListBiz biz = PickListBiz.GetBiz(ct, HttpContext);

            if (!Authorized.HasReadFullRole(HttpContext.Items, biz.BizType))
                return StatusCode(403, new ApiNotAuthorizedResponse());

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            var o = await biz.GetAsync(ayaType);
            if (o == null)
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            return Ok(ApiOkResponse.Response(o));
        }



        /// <summary>
        /// List of all PickList templates
        /// </summary>        
        /// <returns>List of strings</returns>
        [HttpGet("template/list")]
        public ActionResult GetTemplateList()
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            //Instantiate the business object handler
            PickListBiz biz = PickListBiz.GetBiz(ct, HttpContext);

            long TranslationId = UserTranslationIdFromContext.Id(HttpContext.Items);
            var o = biz.GetListOfAllPickListTypes(TranslationId);
            if (o == null)
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            return Ok(ApiOkResponse.Response(o));

        }




        /// <summary>
        /// POST (replace) Pick List template
        /// (note: in this case the Id is the AyaType numerical value as there is only one template per type)
        /// </summary>       
        /// <param name="template"></param>
        /// <returns></returns>
       // [HttpPost("Template/{ayaType}")]
        [HttpPost("template")]
        public async Task<IActionResult> ReplacePickListTemplate([FromBody] PickListTemplate template)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Instantiate the business object handler       
            PickListBiz biz = PickListBiz.GetBiz(ct, HttpContext);

            // var o = await biz.GetAsync(ayaType, false);
            // if (o == null)
            //     return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            if (!Authorized.HasModifyRole(HttpContext.Items, biz.BizType))
                return StatusCode(403, new ApiNotAuthorizedResponse());

            try
            {
                if (!await biz.ReplaceAsync(template))
                    return BadRequest(new ApiErrorResponse(biz.Errors));
            }
            catch (DbUpdateConcurrencyException)
            {

                return StatusCode(409, new ApiErrorResponse(ApiErrorCode.CONCURRENCY_CONFLICT));
            }
            return NoContent();
        }


        /// <summary>
        /// Delete customized template
        /// (revert to default)
        /// </summary>
        /// <param name="ayaType"></param>
        /// <returns>Ok</returns>
        [HttpDelete("template/{ayaType}")]
        public async Task<IActionResult> DeletePickListTemplate([FromRoute] AyaType ayaType)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Instantiate the business object handler
            PickListBiz biz = PickListBiz.GetBiz(ct, HttpContext);


            if (!Authorized.HasDeleteRole(HttpContext.Items, biz.BizType))
                return StatusCode(403, new ApiNotAuthorizedResponse());

            if (!await biz.DeleteAsync(ayaType))
                return BadRequest(new ApiErrorResponse(biz.Errors));

            return NoContent();
        }


        /// <summary>
        /// List of all fields for pick list AyaType specified
        /// </summary>        
        /// <returns>List of fields available for template</returns>
        [HttpGet("template/listfields/{ayaType}")]
        public ActionResult GetPickListFields([FromRoute] AyaType ayaType)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            var PickList = PickListFactory.GetAyaPickList(ayaType);
            //type might not be supported
            if (PickList == null)
            {
                return BadRequest(new ApiErrorResponse(ApiErrorCode.NOT_FOUND, null, $"PickList for type  \"{ayaType.ToString()}\" not supported"));
            }
            return Ok(ApiOkResponse.Response(PickList.ColumnDefinitions));
        }






    }//eoc
}//ens